﻿using UnityEngine;
using System.Collections;

public class EnterTrigger : MonoBehaviour {

	public static int triggered = 0;
	public Texture2D[] frame1;
	public Texture2D[] frame2;
	
	public AudioSource asource;
	public AudioClip[] clips;

    public GameObject keyholeView;
	public Transform targetCamPos;
	public GameObject keyCover;
	public Material unlittexmat;

	public GameObject clickQuad;
	public GameObject player;
	public GameObject playercam;
	void Start(){
	}
	public void bang(){
		StartCoroutine("DoZoom");
	}
	/*
	void LateUpdate(){
		Cursor.lockState = CursorLockMode.Locked;
		Cursor.visible = false;
		clickQuad.SetActive (enableQuad);
		if (busy) {
			return;
		}
		if (enableQuad&&Input.GetMouseButton (0)) {
			StartCoroutine("DoZoom");
		}
		enableQuad = false;
	}*/

	bool keyHoleSet=false;
	int keyholeindex=0;
	public static bool busy;
	private float clipPos=0;
	float timer6=0;
	IEnumerator DoZoom(){
		if (busy) {
			yield break;
		}
		busy = true;
		player.SetActive (false);
		Debug.Log ("triggered" + triggered);
		if (keyHoleSet == false) {
			keyHoleSet=true;
			keyholeindex=triggered;
			triggered++;
		}
		keyholeView.GetComponent<Renderer> ().material = unlittexmat;
		keyholeView.GetComponent<Renderer> ().material.mainTexture = frame1 [keyholeindex];
		var origPos = playercam.transform.position;
		var origRot = playercam.transform.eulerAngles;
		var oldCamParent = playercam.transform.parent;
		playercam.transform.parent = null;
		clickQuad.SetActive (false);
		
		asource.clip = clips [keyholeindex];
		asource.volume = 0;
		asource.time = clipPos;
		asource.Play ();

		if (keyholeindex == 5) {
			asource.loop = false;
		}

		iTween.MoveTo (playercam, targetCamPos.position, 1.0f);
		iTween.RotateTo (playercam, targetCamPos.eulerAngles, 1.0f);
		iTween.AudioTo (asource.gameObject, 1.0f, 1.0f, 0.5f);
		iTween.RotateToLocal (keyCover, new Vector3 (270, -35, 0), 0.5f);
		yield return new WaitForSeconds (1.0f);
		float timer = 0;
		while (true) {
			if (keyholeindex==5){
				timer6+=Time.deltaTime;
				if (timer6>4){
					var cam = Camera.main;
					cam.cullingMask = 1<<9;
					cam.clearFlags = CameraClearFlags.Color;
					cam.backgroundColor = Color.black;
				}
			}
			if ( (keyholeindex<5&&timer<0.5f)||(keyholeindex==5&&timer<0.9f)){
				keyholeView.GetComponent<Renderer> ().material.mainTexture = frame1 [keyholeindex];
			} else {
				keyholeView.GetComponent<Renderer> ().material.mainTexture = frame2 [keyholeindex];
			}
			playercam.transform.position = targetCamPos.position;
			playercam.transform.eulerAngles = targetCamPos.eulerAngles;
			if (Input.GetMouseButton(0)&&triggered!=6){
				break;
			}
			yield return 0;
			if (keyholeindex==5){
				timer+=Time.deltaTime/2;
			} else {
				timer+=4*Time.deltaTime;
			}
			if (timer>1){
				timer-=1;
			}
		}
		iTween.RotateToLocal (keyCover, new Vector3 (270, 90, 0), 0.5f);
		iTween.AudioTo (asource.gameObject, 0.0f, 1.0f, 0.5f);
		iTween.MoveTo (playercam, origPos, 1.0f);
		iTween.RotateTo (playercam, origRot, 1.0f);
		yield return new WaitForSeconds (1.0f);
		clipPos = asource.time;
		playercam.transform.parent = oldCamParent;
		player.SetActive (true);
		busy = false;
	}
}
