﻿using UnityEngine;
using System.Collections;

public class PlayerRayCast : MonoBehaviour {

	private Camera cam;
	// Use this for initialization
	void Start () {
		cam = Camera.main;	
	}
	public GameObject clickQuad;

	private bool enableQuad=false;
	// Update is called once per frame
	void Update () {
		Cursor.lockState = CursorLockMode.Locked;
		Cursor.visible = false;

		if (EnterTrigger.busy) {
			return;
		}

		
		clickQuad.SetActive (enableQuad);
		var ray = new Ray(cam.transform.position,cam.transform.forward);
		RaycastHit hitInfo;
		enableQuad = false;
		if (Physics.Raycast (ray, out hitInfo,5,~(1<<8))) {
			Debug.Log(hitInfo.collider.name);
			if (hitInfo.collider.gameObject.tag == "door") {
				Debug.Log ("close to, and looking at, door");
				enableQuad=true;
				if (Input.GetMouseButton(0)){
					hitInfo.collider.GetComponent<EnterTrigger>().bang();
				}
				Debug.DrawRay (ray.origin, ray.direction * hitInfo.distance, Color.yellow,2.0f);
			} else {
				Debug.DrawRay (ray.origin, ray.direction * hitInfo.distance, Color.cyan,2.0f);
			}
		} else {
			Debug.DrawRay (ray.origin, ray.direction * 10, Color.red,2.0f);
		}
	}
}
